# Element Summary

Element | Description | Class
--- | --- | ---

pooledConnectionFactory

A JMS provider which pools Connection, Session and MessageProducer instances so it can be used with tools like Camel and Spring's JmsTemplate and MessagListenerContainer. Connections, sessions and producers are returned to a pool after use so that they can be reused later without having to undergo the cost of creating them again. b>NOTE: while this implementation does allow the creation of a collection of active consumers, it does not 'pool' consumers. Pooling makes sense for connections, sessions and producers, which are expensive to create and can remain idle a minimal cost. Consumers, on the other hand, are usually just created at startup and left active, handling incoming messages as they come. When a consumer is complete, it is best to close it rather than return it to a pool for later reuse: this is because, even if a consumer is idle, ActiveMQ will keep delivering messages to the consumer's prefetch buffer, where they'll get held until the consumer is active again. If you are creating a collection of consumers (for example, for multi-threaded message consumption), you might want to consider using a lower prefetch value for each consumer (e.g. 10 or 20), to ensure that all messages don't end up going to just one of the consumers. See this FAQ entry for more detail: http://activemq.apache.org/i-do-not-receive-messages-in-my-second-consumer.html

org.apache.aries.transaction.jms.PooledConnectionFactory

xaPooledConnectionFactory | A pooled connection factory which is dedicated to work with the Geronimo/Aries transaction manager for proper recovery of in-flight transactions after a crash. | org.apache.aries.transaction.jms.RecoverablePooledConnectionFactory

# Element Detail

## Element: pooledConnectionFactory

Attribute | Type | Description
--- | --- | ---
blockIfSessionPoolIsFull | xs:boolean | Controls the behavior of the internal session pool. By default the call to Connection.getSession() will block if the session pool is full. If the argument false is given, it will change the default behavior and instead the call to getSession() will throw a JMSException. The size of the session pool is controlled by the @see #maximumActive property.
expiryTimeout | xs:long | Allow connections to expire, irrespective of load or idle time. This is useful with failover to force a reconnect from the pool, to reestablish load balancing or use of the master post recovery.
idleTimeout | xs:integer | Specifies the amount of milliseconds after which an idle connection is discarded. Defaults to 30 seconds.
maxConnections | xs:integer | Number of JMS connections to use. The default is 1 to use a single connection to the broker. For high throughput, it may be interesting to raise this number a bit.
maximumActive | xs:integer | Sets the maximum number of active sessions per connection

Element | Type | Description
--- | --- | ---
connectionFactory | pooledConnectionFactory | xaPooledConnectionFactory | The actual JMS ConnectionFactory that will be pooled.
poolFactory | <spring:bean/> | Sets the object pool factory used to create individual session pools for each connection

## Element: xaPooledConnectionFactory

Attribute | Type | Description
--- | --- | ---
blockIfSessionPoolIsFull | xs:boolean | Controls the behavior of the internal session pool. By default the call to Connection.getSession() will block if the session pool is full. If the argument false is given, it will change the default behavior and instead the call to getSession() will throw a JMSException. The size of the session pool is controlled by the @see #maximumActive property.
expiryTimeout | xs:long | Allow connections to expire, irrespective of load or idle time. This is useful with failover to force a reconnect from the pool, to reestablish load balancing or use of the master post recovery.
idleTimeout | xs:integer | Specifies the amount of milliseconds after which an idle connection is discarded. Defaults to 30 seconds.
maxConnections | xs:integer | Number of JMS connections to use. The default is 1 to use a single connection to the broker. For high throughput, it may be interesting to raise this number a bit.
maximumActive | xs:integer | Sets the maximum number of active sessions per connection
name | xs:string | The unique name for this managed XAResource. This name will be used by the transaction manager to recover transactions.

Element | Type | Description
--- | --- | ---
connectionFactory | pooledConnectionFactory | xaPooledConnectionFactory | The actual JMS ConnectionFactory that will be pooled.
poolFactory | <spring:bean/> | Sets the object pool factory used to create individual session pools for each connection
transactionManager | <spring:bean/> | The XA TransactionManager to use to enlist the JMS sessions into.
xaConnectionFactory | <spring:bean/> |